#include <inttypes.h>
#include <shade.h>

void *asmsrc;
unsigned int asmpitch;
unsigned int asmw, asmh;
unsigned int asmr,asmg,asmb;

/* for external assembler routines must require C linkage
   if included in c++ files */
extern "C" {
void shade_ximage_16_mmx(void *data, int bpl, int w, int h, int rm, int gm, int bm);
void shade_ximage_32_mmx(void *data, int bpl, int w, int h, int rm, int gm, int bm);
}

Shade::Shade() {
  initialized = false;
  /* procbuf = NULL; */
  
  supported[0] = false;
  supported[1] = true;
  supported[2] = false;
  supported[3] = true;

  strcpy(name,"Shade");
  strcpy(author,"Willem Monsuwe, Michael Jennings, jaromil@dyne.org");
  version = 1;
}

bool Shade::init() {
  func("Shade::init");

  r = g = b = 0x0;
  return(true);
}

void *Shade::process(void *buffo) {

  switch(bpp) {
  case 16:
    shade_ximage_16_mmx();
    break;
  case 32:
    shade_ximage_32_mmx();
    break;
  }
  
  return buffo;
}

void Shade::_delete() {
  func("Shade::_delete()");
}

bool Shade::kbd_input(SDL_keysym *keysym) {
  bool res = true;
  int step = (keysym->mod==KMOD_SHIFT) ? 10 : 1;

  switch(keysym->sym) {
  case SDLK_w:
    r += step;
    break;
  case SDLK_q:
    r -= step;
    break;
  case SDLK_s:
    g += step;
    break;
  case SDLK_a:
    g -= step;
    break;    
  case SDLK_x:
    b += step;
    break;
  case SDLK_z:
    b -= step;
    break;
  default:
    res = false;
    break;
  }
  return res;
}
